<?php

class DispletRetsIdxLoadController extends DispletRetsIdxPlugin {
	public static function enqueue() {
		include_once( ABSPATH . 'wp-admin/includes/plugin.php' );
		self::enqueue_css( 'displet-rets-idx-styles.css' );
		self::enqueue_js( 'displet-rets-idx-scripts.js', array( 'jquery', 'jquery-ui-core', 'jquery-ui-datepicker' ) );
		self::enqueue_js( 'modernizr.placeholder.min.js', array( 'jquery' ) );
		if ( !empty( self::$_options['board_translations'] ) && self::$_options['board_translations'] != 'none' ) {
			self::enqueue_js( 'displet-listing-translations-scripts.js', array( 'jquery' ) );
			self::enqueue_js( 'displet-listing-translations-variables-' . self::$_options['board_translations'] . '.js', array( 'jquery' ) );
		}
	}

	public static function enqueue_admin() {
		self::enqueue_css( 'displet-rets-idx-admin-styles.css' );
		self::enqueue_js( 'displet-rets-idx-admin-scripts.js', array( 'jquery', 'jquery-ui-core', 'jquery-ui-datepicker', 'jquery-ui-dialog', 'jquery-ui-tabs', 'admin-widgets' ) );
		wp_enqueue_style( 'wp-pointer' );
		wp_enqueue_script( 'wp-pointer' );
	}

	public static function enqueue_admin_settings() {
		self::enqueue_js( 'displet-rets-idx-photo-upload.js', array( 'jquery', 'media-upload', 'thickbox' ) );
		wp_enqueue_style( 'thickbox' );
	}

	public static function enqueue_css( $filename ) {
		$custom_template_uri = self::get_custom_template_uri( $filename );
		if ( !empty( $custom_template_uri ) ) {
			$stylesheet_url = $custom_template_uri;
		}
		else{
			$stylesheet_url = plugins_url( self::$_slug . '/includes/css/' . $filename );
		}
		$slug = basename( $filename, '.css' );
		wp_enqueue_style( $slug, $stylesheet_url, false, parent::$plugin_version );
	}

	public static function enqueue_js( $filename, $dependencies = array() ) {
		$script_url = plugins_url( self::$_slug . '/includes/js/' . $filename );
		$slug = basename( $filename, '.js' );
		wp_enqueue_script( $slug, $script_url, $dependencies, parent::$plugin_version );
	}

	public static function get_custom_template_uri( $filename ) {
		if ( empty( self::$_options['disable_custom_templates'] ) ) {
			$theme_dir = get_stylesheet_directory();
			if ( file_exists( $theme_dir . '/' . $filename ) ) {
				$theme_url = get_stylesheet_directory_uri();
				return $theme_url . '/' . $filename;
			}
			else if ( file_exists( ABSPATH . 'wp-content/plugins/displet-pro-custom/' . $filename ) && is_plugin_active( 'displet-pro-custom/displet-pro-custom.php' ) ) {
				return plugins_url( 'displet-pro-custom/' . $filename );
			}
		}
		return false;
	}
}

?>