<?php

class DispletRetsIdxSearchFieldWidgetController extends DispletRetsIdxSearchFieldWidgetModel {
	public static function get_search_field_markup( $field, $title ) {
        switch ( $field ) {
			case 'acres_min' :
				$markup = self::get_acres_min( $title );
				break;
			case 'area_mls_defined' :
				$markup = self::get_area_mls_defined( $title, true );
				break;
			case 'area_mls_defined_select' :
				$markup = self::get_area_mls_defined( $title );
				break;
			case 'basement' :
				$markup = self::get_basement( $title );
				break;
			case 'baths' :
				$markup = self::get_baths( $title );
				break;
			case 'baths_max' :
				$markup = self::get_baths_max( $title );
				break;
			case 'beds' :
				$markup = self::get_beds( $title );
				break;
			case 'beds_baths' :
				$markup = self::get_beds_baths( $title );
				break;
			case 'beds_max' :
				$markup = self::get_beds_max( $title );
				break;
			case 'city' :
				$markup = self::get_city( $title, true );
				break;
			case 'city_select' :
				$markup = self::get_city( $title );
				break;
			case 'county' :
				$markup = self::get_county( $title );
				break;
			case 'foreclosure' :
				$markup = self::get_foreclosure( $title );
				break;
			case 'is_gated_community' :
				$markup = self::get_is_gated_community( $title );
				break;
			case 'keywords' :
				$markup = self::get_keywords( $title );
				break;
			case 'last_modified' :
				$markup = self::get_last_modified( $title );
				break;
			case 'listed_since' :
				$markup = self::get_listed_since( $title );
				break;
			case 'master_on_main' :
				$markup = self::get_master_on_main( $title );
				break;
			case 'mls_number' :
				$markup = self::get_mls_number( $title );
				break;
			case 'new_construction' :
				$markup = self::get_new_construction( $title );
				break;
			case 'pool' :
				$markup = self::get_pool( $title );
				break;
			case 'price_min' :
				$markup = self::get_price_min( $title );
				break;
			case 'price_max' :
				$markup = self::get_price_max( $title );
				break;
			case 'price' :
				$markup = self::get_price( $title );
				break;
			case 'property_type' :
				$markup = self::get_property_type( $title, true );
				break;
			case 'property_type_select' :
				$markup = self::get_property_type( $title );
				break;
			case 'quick_terms' :
				$markup = self::get_quick_terms( $title );
				break;
			case 'school' :
				$markup = self::get_school( $title );
				break;
			case 'school_district' :
				$markup = self::get_school_district( $title, true );
				break;
			case 'school_district_select' :
				$markup = self::get_school_district( $title );
				break;
			case 'short_sale' :
				$markup = self::get_short_sale( $title );
				break;
			case 'square_feet_min' :
				$markup = self::get_square_feet_min( $title );
				break;
			case 'square_feet_max' :
				$markup = self::get_square_feet_max( $title );
				break;
			case 'square_feet' :
				$markup = self::get_square_feet( $title );
				break;
			case 'status' :
				$markup = self::get_status( $title, true );
				break;
			case 'status_select' :
				$markup = self::get_status( $title );
				break;
			case 'stories' :
				$markup = self::get_stories( $title );
				break;
			case 'subdivision' :
				$markup = self::get_subdivision( $title );
				break;
			case 'waterfront' :
				$markup = self::get_waterfront( $title );
				break;
			case 'year_built' :
				$markup = self::get_year_built( $title );
				break;
			case 'zip' :
				$markup = self::get_zip( $title );
				break;
		}
		return $markup;
	}

	public static function get_search_field_widget_form( $self, $instance ) {
		if ( $instance['field'] == 'beds_baths' ) {
			$instance['title'] = 'Beds/Baths';
		}
		else if ( $instance['field'] == 'price' ) {
			$instance['title'] = 'Price Min/Max';
		}
		else if ( $instance['field'] == 'square_feet' ) {
			$instance['title'] = 'Square Feet Min/Max';
		}
		$form = self::get_search_field_widget_form_javascript();
		$label_style = ( $instance['field'] === 'beds_baths' || $instance['field'] === 'price' || $instance['field'] === 'square_feet' ) ? ' style="display:none;"' : '';
		$form .=
			'<p class="displet-label ' . $self->get_field_id( 'title' ) . '"' . $label_style . '>
				<label for="' . $self->get_field_id( 'title' ) . '">
					Label:
				</label>
				<input class="widefat" id="' . $self->get_field_id( 'title' ) . '" name="' . $self->get_field_name( 'title' ) . '" type="text" value="' . esc_attr( $instance['title'] ) . '" />
			</p>
			<p class="displet-field">
				<label for="' . $self->get_field_id( 'field' ) . '">
					Field:
				</label>
				<select class="widefat" id="' . $self->get_field_id( 'field' ) . '" name="' . $self->get_field_name( 'field' ) . '">';
		foreach ( self::$fields as $field => $value ) {
			$disabled = ( !empty( self::$_options['displet_app_key'] ) || !empty( $value['non_idx'] ) ) ? '' : ' disabled';
			$selected = $instance['field'] === $field ? ' selected' : '';
			$upgrade = !empty( $disabled ) ? ' - Available w/ Upgrade' : '';
			$form .= '<option value="' . $field . '"' . $disabled . $selected . '>
						' . $value['title'] . $upgrade . '
					</option>';
		}
		$form .=
				'</select>
			</p>';
		return $form;
	}

	private static function get_search_field_widget_form_javascript() {
		return
			"<script>
				jQuery('.displet-field select').unbind('change').bind('change', function(){
					displetretsidx_update_search_field_widget_label(this);
				});
			</script>";
	}

	public static function is_advanced_search_form_widget_area_used( $i ) {
		if ( is_active_sidebar( 'displetretsidx-search-form-advanced-' . $i ) ) {
			return true;
		}
		return false;
	}

	public static function is_mobile_search_form_widget_area_used( $i ) {
		if ( is_active_sidebar( 'displetretsidx-search-form-mobile-' . $i ) ) {
			return true;
		}
		return false;
	}

	public static function is_search_form_widget_area_used( $i ) {
		if ( is_active_sidebar( 'displetretsidx-search-form-' . $i ) ) {
			return true;
		}
		return false;
	}

	public static function register_default_widgets() {
		$widgets = get_option( 'widget_displetretsidxsearchfield' );
		if ( empty( $widgets[1] ) ) {
			$widgets[1] = array(
				'title' => 'Property Type',
				'field' => 'property_type'
			 );
		}
		if ( empty( $widgets[2] ) ) {
			$widgets[2] = array(
				'title' => 'Price Min/Max',
				'field' => 'price'
			 );
		}
		if ( empty( $widgets[3] ) ) {
			$widgets[3] = array(
				'title' => 'Beds/Baths',
				'field' => 'beds_baths'
			 );
		}
		if ( empty( $widgets[4] ) ) {
			$widgets[4] = array(
				'title' => 'City, Zip, Neighborhood, or Condo',
				'field' => 'quick_terms'
			 );
		}
		if ( empty( $widgets[5] ) ) {
			$widgets[5] = array(
				'title' => 'Keywords: Ex. Pool, Modern, Foreclosure',
				'field' => 'keywords'
			 );
		}
		if ( empty( $widgets[6] ) ) {
			$widgets[6] = array(
				'title' => 'Foreclosure',
				'field' => 'foreclosure'
			 );
		}
		if ( empty( $widgets[7] ) ) {
			$widgets[7] = array(
				'title' => 'School District',
				'field' => 'school_district'
			 );
		}
		if ( empty( $widgets[8] ) ) {
			$widgets[8] = array(
				'title' => 'School',
				'field' => 'school'
			 );
		}
		if ( empty( $widgets[9] ) ) {
			$widgets[9] = array(
				'title' => 'Pool',
				'field' => 'pool'
			 );
		}
		if ( empty( $widgets[10] ) ) {
			$widgets[10] = array(
				'title' => 'Waterfront',
				'field' => 'waterfront'
			 );
		}
		if ( empty( $widgets[11] ) ) {
			$widgets[11] = array(
				'title' => 'Property Type',
				'field' => 'property_type_select'
			 );
		}
		if ( empty( $widgets[12] ) ) {
			$widgets[12] = array(
				'title' => 'Price Min/Max',
				'field' => 'price'
			 );
		}
		if ( empty( $widgets[13] ) ) {
			$widgets[13] = array(
				'title' => 'Beds/Baths',
				'field' => 'beds_baths'
			 );
		}
		if ( empty( $widgets[14] ) ) {
			$widgets[14] = array(
				'title' => 'City, Zip, Neighborhood, or Condo',
				'field' => 'quick_terms'
			 );
		}
		if ( empty( $widgets[15] ) ) {
			$widgets[15] = array(
				'title' => 'Keywords: Ex. Pool, Modern, Foreclosure',
				'field' => 'keywords'
			 );
		}
		if ( empty( $widgets[16] ) ) {
			$widgets[16] = array(
				'title' => 'City, Zip, Neighborhood, or Condo',
				'field' => 'quick_terms'
			 );
		}
		if ( empty( $widgets[17] ) ) {
			$widgets[17] = array(
				'title' => 'Price Min/Max',
				'field' => 'price'
			 );
		}
		if ( empty( $widgets[18] ) ) {
			$widgets[18] = array(
				'title' => 'Beds/Baths',
				'field' => 'beds_baths'
			 );
		}
		if ( empty( $widgets[19] ) ) {
			$widgets[19] = array(
				'title' => 'Keywords: Ex. Pool, Modern, Foreclosure',
				'field' => 'keywords'
			 );
		}
		if ( empty( $widgets[20] ) ) {
			$widgets[20] = array(
				'title' => 'City, Zip, Neighborhood, or Condo',
				'field' => 'quick_terms'
			 );
		}
		if ( empty( $widgets[21] ) ) {
			$widgets[21] = array(
				'title' => 'Price Min/Max',
				'field' => 'price'
			 );
		}
		if ( empty( $widgets[22] ) ) {
			$widgets[22] = array(
				'title' => 'Beds/Baths',
				'field' => 'beds_baths'
			 );
		}
		if ( empty( $widgets[23] ) ) {
			$widgets[23] = array(
				'title' => 'Keywords: Ex. Pool, Modern, Foreclosure',
				'field' => 'keywords'
			 );
		}
		update_option( 'widget_displetretsidxsearchfield', $widgets );
	}

	public static function register_default_widget_areas_content() {
		$sidebars = get_option( 'sidebars_widgets' );
		$need_sidebars_update = false;
		if ( empty( $sidebars['displetretsidx-search-form-1'] ) ) {
			$need_sidebars_update = true;
			$sidebars['displetretsidx-search-form-1'] = array(
				'displetretsidxsearchfield-1',
				'displetretsidxsearchfield-2',
				'displetretsidxsearchfield-3'
			 );
			$sidebars['displetretsidx-search-form-2'] = array(
				'displetretsidxsearchfield-4',
				'displetretsidxsearchfield-5',
				'displetretsidxsearchfield-6'
			 );
			$sidebars['displetretsidx-search-form-advanced-1'] = array(
				'displetretsidxsearchfield-7',
				'displetretsidxsearchfield-8'
			 );
			$sidebars['displetretsidx-search-form-advanced-2'] = array(
				'displetretsidxsearchfield-9',
				'displetretsidxsearchfield-10'
			 );
		}
		if ( empty( $sidebars['displetretsidx-quick-search-1-form-1'] ) ) {
			$need_sidebars_update = true;
			$sidebars['displetretsidx-quick-search-1-form-1'] = array(
				'displetretsidxsearchfield-11',
				'displetretsidxsearchfield-12',
				'displetretsidxsearchfield-13',
				'displetretsidxsearchfield-14',
				'displetretsidxsearchfield-15'
			 );
		}
		if ( empty( $sidebars['displetretsidx-quick-search-form-mobile'] ) ) {
			$need_sidebars_update = true;
			$sidebars['displetretsidx-quick-search-form-mobile'] = array(
				'displetretsidxsearchfield-16',
				'displetretsidxsearchfield-17',
				'displetretsidxsearchfield-18',
				'displetretsidxsearchfield-19'
			 );
		}
		if ( empty( $sidebars['displetretsidx-search-form-mobile'] ) ) {
			$need_sidebars_update = true;
			$sidebars['displetretsidx-search-form-mobile'] = array(
				'displetretsidxsearchfield-20',
				'displetretsidxsearchfield-21',
				'displetretsidxsearchfield-22',
				'displetretsidxsearchfield-23'
			 );
		}
		if ( $need_sidebars_update ) {
			update_option( 'sidebars_widgets', $sidebars );
		}
    }

	public static function add_search_form_widget_area() {
		register_sidebar( array(
			'name' => 'Displet Search Form',
			'id' => 'displetretsidx-search-form-1',
			'description' => 'Column 1 of the search form. Use Displet Search Field widgets here. Refresh the page after adding a field to allow use of another column.',
			'before_widget' => '<div class="displet-field displet-left">',
			'after_widget' => '</div>',
			'before_title' => '',
			'after_title' => '',
		 ) );
		if ( self::is_search_form_widget_area_used( 1 ) ) {
			$i = 1;
			while ( self::is_search_form_widget_area_used( $i ) ) {
				$i++;
				register_sidebar( array(
					'name' => 'Displet Search Form',
					'id' => 'displetretsidx-search-form-' . $i,
					'description' => 'Column ' . $i . ' of the search form. Use Displet Search Field widgets here. Refresh the page after adding a field to allow use of another column. Leave empty to not include this column.',
					'before_widget' => '<div class="displet-field displet-left">',
					'after_widget' => '</div>',
					'before_title' => '',
					'after_title' => '',
				 ) );
			}
		}
		register_sidebar( array(
			'name' => 'Displet Search Form - Adv. Section',
			'id' => 'displetretsidx-search-form-advanced-1',
			'description' => 'Column 1 of the advanced section of the search form. Use Displet Search Field widgets here. Refresh the page after adding a field to allow use of another column. Leave empty to not include an advanced section.',
			'before_widget' => '<div class="displet-field displet-left">',
			'after_widget' => '</div>',
			'before_title' => '',
			'after_title' => '',
		 ) );
		if ( self::is_advanced_search_form_widget_area_used( 1 ) ) {
			$i = 1;
			while ( self::is_advanced_search_form_widget_area_used( $i ) ) {
				$i++;
				register_sidebar( array(
					'name' => 'Displet Search Form - Adv. Section',
					'id' => 'displetretsidx-search-form-advanced-' . $i,
					'description' => 'Column ' . $i . ' of the advanced section of the search form. Use Displet Search Field widgets here. Refresh the page after adding a field to allow use of another column. Leave empty to not include this column.',
					'before_widget' => '<div class="displet-field displet-left">',
					'after_widget' => '</div>',
					'before_title' => '',
					'after_title' => '',
				 ) );
			}
		}
		if ( !empty( self::$_options['mobile_version'] ) ) {
			register_sidebar( array(
				'name' => 'Displet Mobile Search Form',
				'id' => 'displetretsidx-search-form-mobile',
				'description' => 'Use Displet Search Field widgets here.',
				'before_widget' => '<div class="displet-field">',
				'after_widget' => '</div>',
				'before_title' => '',
				'after_title' => '',
			 ) );
			register_sidebar( array(
				'name' => 'Displet Mobile Quick Search Form',
				'id' => 'displetretsidx-quick-search-form-mobile',
				'description' => 'Use Displet Search Field widgets here.',
				'before_widget' => '<div class="displet-field">',
				'after_widget' => '</div>',
				'before_title' => '',
				'after_title' => '',
			 ) );
		}
	}

	public static function is_quick_search_form_column_used( $form, $column ) {
		if ( is_active_sidebar( 'displetretsidx-quick-search-' . $form . '-form-' . $column ) ) {
			return true;
		}
		return false;
	}

	public static function add_quick_search_form_widget_area() {
		register_sidebar( array(
			'name' => 'Displet Quick Search 1 Form',
			'id' => 'displetretsidx-quick-search-1-form-1',
			'description' => 'Column 1 of the Quick Search 1 Form. Use Displet Search Field widgets here. Refresh the page after adding a field to allow use of another column.',
			'before_widget' => '<div class="displet-field displet-left">',
			'after_widget' => '</div>',
			'before_title' => '',
			'after_title' => '',
		 ) );
		if ( self::is_quick_search_form_column_used( 1, 1 ) ) {
			$form = 1;
			$column = 1;
			while ( $form <= 5 && self::is_quick_search_form_column_used( $form, 1 ) ) {
				while ( self::is_quick_search_form_column_used( $form, $column ) ) {
					$column++;
					register_sidebar( array(
						'name' => 'Displet Quick Search ' . $form . ' Form',
						'id' => 'displetretsidx-quick-search-' . $form . '-form-' . $column,
						'description' => 'Column ' . $column . ' of the Quick Search ' . $form . ' Form. Use Displet Search Field widgets here. Refresh the page after adding a field to allow use of another column. Leave empty to not include this column.',
						'before_widget' => '<div class="displet-field displet-left">',
						'after_widget' => '</div>',
						'before_title' => '',
						'after_title' => '',
					 ) );
				}
				$form++;
				$column = 1;
				register_sidebar( array(
					'name' => 'Displet Quick Search ' . $form . ' Form',
					'id' => 'displetretsidx-quick-search-' . $form . '-form-' . $column,
					'description' => 'Column ' . $column . ' of the Quick Search ' . $form . ' Form. Use Displet Search Field widgets here. Refresh the page after adding a field to allow use of another column. Leave empty to not include this column.',
					'before_widget' => '<div class="displet-field displet-left">',
					'after_widget' => '</div>',
					'before_title' => '',
					'after_title' => '',
				 ) );
			}
		}
	}

	public static function property_type_array_filter_callback( $var ) {
		if ( $var == 'false' ) {
			return false;
		}
		else{
			return $var;
		}
	}

	public static function register_widget() {
		register_widget( 'DispletRetsIdxSearchField' );
	}
}

?>